require('split_helper')

local function debug(A, B, C, D) end

fogcache_auth = {}

local RESPONSE_AUTH_REQUIRED_HTML = [[<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
 "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<HTML>
  <HEAD>
    <TITLE>Error</TITLE>
    <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=ISO-8859-1">
  </HEAD>
  <BODY><H1>401 Unauthorized.</H1></BODY>
</HTML>]]

function fogcache_auth.authUserPassword(Request)
   if Request.headers.Authorization == nil then
      return nil, nil
   end
   local AuthHeaderWordList = split_helper.split(Request.headers.Authorization, ' ')
   debug(AuthHeaderWordList)
   assert( AuthHeaderWordList[1]:lower() == 'basic')
   assert( #AuthHeaderWordList == 2)
   local AuthDataDecoded = filter.base64.dec(AuthHeaderWordList[2])
   local UserPassword = split_helper.split(AuthDataDecoded, ':')
   assert( #UserPassword == 2)
   return UserPassword[1], UserPassword[2]
end

function fogcache_auth.respondAuthRequired()
   net.http.respond{code=401, body=RESPONSE_AUTH_REQUIRED_HTML, 
   headers={['WWW-Authenticate']='Basic realm="Secure Webservice"'}}
end
